<template>
  <div>
    <v-app-bar height="30">
      <v-tooltip bottom>
        <template v-slot:activator="{ on }">
          <v-btn icon color="red" v-on="on">
            <v-icon @click="clearOutParams(itemTab)"
              >mdi-pencil-box-outline</v-icon
            >
          </v-btn>
        </template>
        <span>Limpiar variables</span>
      </v-tooltip>
    </v-app-bar>
    <v-card tile :elevation="0">
      <v-toolbar :elevation="1">
        <v-toolbar-title>Variables</v-toolbar-title>
      </v-toolbar>
      <v-tabs :centered="true" vertical>
        <template v-for="(itemSimple, indexItemSimple) in outParams.simple">
          <v-tab :key="'simple' + indexItemSimple">
            <v-icon left>mdi-arrow-right-bold-box-outline</v-icon>
            {{ itemSimple.name }}
          </v-tab>
        </template>
        <template v-for="(itemGrid, indexItemGrid) in outParams.grids">
          <v-tab :key="indexItemGrid">
            <v-icon left>mdi-arrow-right-bold-box-outline</v-icon>
            {{ itemGrid.name }}
          </v-tab>
        </template>
        <template v-for="(itemSimple, indexItemSimple) in outParams.simple">
          <v-tab-item :key="'simple' + indexItemSimple">
            <v-tabs>
              <v-tabs-slider></v-tabs-slider>
              <v-tab>
                Valor
              </v-tab>
              <v-tab-item>
                {{ itemSimple.value }}
              </v-tab-item>
            </v-tabs>
          </v-tab-item>
        </template>
        <template v-for="(itemGrid, indexItemGrid) in outParams.grids">
          <v-tab-item :key="indexItemGrid">
            <v-tabs>
              <v-tabs-slider></v-tabs-slider>
              <v-tab>
                Valor
              </v-tab>
              <v-tab-item>
                <div class="text-right mt-5 mb-5 mr-5">
                  <v-btn
                    color="secondary"
                    tile
                    depressed
                    @click="exportToJSON(itemGrid)"
                    >Exportar a JSON</v-btn
                  >
                  <v-btn
                    class="ml-5"
                    color="secondary"
                    tile
                    depressed
                    @click="exportToExcel(itemGrid)"
                    >Exportar a Excel</v-btn
                  >
                </div>
                <v-card>
                  <v-card-title>
                    Datos
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="itemGrid.search"
                      append-icon="mdi-magnify"
                      label="Buscar"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    :loading="isLoading"
                    height="400"
                    fixed-header
                    :search="itemGrid.search"
                    :key="'grid' + indexItemGrid"
                    :headers="itemGrid.headers"
                    :items="itemGrid.rows"
                  ></v-data-table>
                </v-card>
              </v-tab-item>
            </v-tabs>
          </v-tab-item>
        </template>
      </v-tabs>
    </v-card>
  </div>
</template>
<style scoped></style>
<script>
import FileSaver from "file-saver";
import axios from "axios";
export default {
  name: "Component-OutParams",
  props: {
    itemTab: Object
  },
  data: () => ({}),
  computed: {
    isLoading() {
      return this.itemTab.isLoading;
    },
    outParams() {
      return this.itemTab.outParams;
    },
    clearOutParams() {
      return this.itemTab.clearOutParams;
    }
  },
  methods: {
    exportToJSON(data) {
      let nameFile = data.name.toLowerCase() + ".json";
      const json = JSON.stringify(data.rows, null, 2);
      var a = document.createElement("a");
      var file = new Blob([json], { type: "application/json;charset=utf-8;" });
      a.href = URL.createObjectURL(file);
      a.download = nameFile;
      a.click();
    },
    convertToCSV(objArray) {
      const array =
        typeof objArray != "object" ? JSON.parse(objArray) : objArray;
      let str = "";
      for (let i = 0; i < array.length; i++) {
        let line = "";
        for (let index in array[i]) {
          if (line != "") line += ",";

          line += array[i][index];
        }
        str += line + "\r\n";
      }
      return str;
    },
    exportToExcel(data) {
      const dataFinal = {};
      dataFinal[data.name.toLowerCase()] = data.rows;
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    exportToCSV(data) {
      const headers = JSON.parse(JSON.stringify(data.headers));
      let finalHeaders = {};
      const items = JSON.parse(JSON.stringify(data.rows));
      if (headers) {
        for (let indexHeader in headers) {
          finalHeaders[headers[indexHeader].text] = headers[indexHeader].text;
        }
        items.unshift(finalHeaders);
      }
      const jsonObject = JSON.stringify(items);
      const csv = this.convertToCSV(jsonObject);
      let nameFile = data.name.toLowerCase() + ".csv";
      var a = document.createElement("a");
      var file = new Blob([csv], { type: "text/csv;charset=utf-8;" });
      a.href = URL.createObjectURL(file);
      a.download = nameFile;
      a.click();
    }
  },
  created() {}
};
</script>
